package top.dreamcenter.noise.util;

public class Dot {
    public double x;
    public double y;
    public int cpt;
    public int grid;

    public Dot(double x, double y, int cpt, int grid) {
        this.x = x;
        this.y = y;
        this.cpt = cpt;
        this.grid = grid;
    }

    /**
     * 转为虚拟坐标
     */
    public void toV() {
        x = (x - cpt) / grid;
        y = (cpt - y) / grid;
    }

    public Dot getV() {
        Dot tmp = new Dot(x, y , cpt, grid);
        tmp.toV();
        return tmp;
    }

    /**
     * 转为实际坐标
     */
    public void toR () {

        x = x * grid + cpt;
        y = cpt - y * grid;
    }

    public Dot getR() {
        Dot tmp = new Dot(x, y , cpt, grid);
        tmp.toR();
        return tmp;
    }

    public DotInt toInt(){
        return new DotInt((int) x, (int) y);
    }

    public static class DotInt{
        public int x;
        public int y;

        public DotInt(int x, int y) {
            this.x = x;
            this.y = y;
        }
    }
}
